//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <memory>
#include <winuser.h>
#include <conio.h> //  getch()
#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;
std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

//     auto_ptr
// -     NULL
template <class T>
ostream& operator<< (ostream& strm, const auto_ptr<T>& p)
{
  //     ?
  if (p.get() == NULL)
  {
    strm << "NULL";  // :   NULL
  }
  else
  {
    strm << *p;      // :  
  }
  return strm;
}

int main(int argc, char* argv[])
{
  auto_ptr <int> p(new int(42));
  auto_ptr <int> q;
  cout << ToRus(" :") << endl;
  cout <<" p: " << p << endl;
  cout <<" q: " << q << endl;
  q = p;
  cout << ToRus("   :") << endl;
  cout <<" p: " << p << endl;
  cout <<" q: " << q << endl;
  *q += 13; //  ,  q
  p = q;
  cout << ToRus("     :") << endl;
  cout <<" p: " << p << endl;
  cout <<" q: " << q << endl;

  getch();
  return 0;
}
//---------------------------------------------------------------------------
